/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.gebietsbaum.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="GEBIETSART.UK",
     query="SELECT o FROM Gebietsart o WHERE "

                         + "o"
                +".name"
              +" = ?1"

             +" AND "         + "o"
                +".mandant"
                +".nummer"
              +" = ?2"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="GEBIETSART.All",
     query="SELECT o FROM Gebietsart o WHERE o.mandant=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="GEBIETSART.AllOrderByPosition",
     query="SELECT o FROM Gebietsart o WHERE o.mandant=?1 ORDER BY o.position",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="GEBIETSART.GebieteInWahl",
     query="SELECT o FROM Gebietsart o WHERE EXISTS (SELECT e FROM Gebiet e WHERE e.wahl = ?1 and e.gebietsart=o)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="GEBIETSART.GebieteInWahlVorhanden",
     query="SELECT ga FROM Gebietsart ga WHERE EXISTS (SELECT g FROM Gebiet g WHERE g.gebietsart = ga AND g.wahl = ?1)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="GEBIETSART.InMandantVerwendet",
     query="SELECT ga FROM Gebietsart ga WHERE ga.mandant=?1 AND EXISTS (SELECT g FROM Gebiet g WHERE g.gebietsart = ga)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="GEBIETSART.Name",
     query="SELECT o FROM Gebietsart o WHERE o.mandant=?1 AND o.name=?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="GEBIETSART.WahlartAndDirektwahlgebiet",
     query="SELECT o FROM Gebietsart o where exists (select e from Gebietsarteigenschaft e WHERE e.wahlart = ?1 and e.gebietsart=o and e.direktwahlgebiet=?2)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="GEBIETSART.WahlartAndListenwahlgebiet",
     query="SELECT o FROM Gebietsart o where exists (select e from Gebietsarteigenschaft e WHERE e.wahlart = ?1 and e.gebietsart=o and e.listenwahlgebiet=?2)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="GEBIETSART.WahlartAndWahlgebiet",
     query="SELECT o FROM Gebietsart o where exists (select e from Gebietsarteigenschaft e WHERE e.wahlart = ?1 and e.gebietsart=o and e.wahlgebiet=?2)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="GEBIETSART.Wahlart",
     query="SELECT o FROM Gebietsart o where EXISTS (select e from Gebietsarteigenschaft e WHERE e.wahlart = ?1 and e.gebietsart=o)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "GEBIETSART")
// @javax.persistence.IdClass(GebietsartPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Gebietsart
extends AbstractGebietsart
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Gebietsart() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Gebietsart(Gebietsart original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "gebietsart_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Gebietsart")
    @javax.persistence.TableGenerator(name = "Gebietsart", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Gebietsart", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient GebietsartPK pkCache;

  @Override
  public GebietsartPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new GebietsartPK(getId());
    }

    return pkCache;
  }

  public static <E extends Gebietsart> java.util.Map<GebietsartPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<GebietsartPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Gebietsart> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedBezirksart = false;
          hasChangedDarstellung = false;
          hasChangedIcon = false;
          hasChangedKennzeichen = false;
          hasChangedName = false;
          hasChangedPosition = false;
          hasChangedSystemGebietsebene = false;
          hasChangedTitel = false;
  
      hasChangedMandant = false;
  

                
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "BEZIRKSART", nullable = GebietsartConstants.BEZIRKSART_NULLABLE)
    
  protected de.ivu.elect.business.gebietsbaum.entity.GebietsartBezirksart bezirksart =  de.ivu.elect.business.gebietsbaum.entity.GebietsartBezirksart.KEINE;

  @javax.persistence.Transient
  protected boolean hasChangedBezirksart = false;

  public boolean hasChangedBezirksart(){
    return hasChangedBezirksart;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBezirksart = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.gebietsbaum.entity.GebietsartBezirksart wertNachLadenBezirksart;
  
  /**
   * 
   *
   * getter for GEBIETSART.BEZIRKSART
   */
    @Override   public  de.ivu.elect.business.gebietsbaum.entity.GebietsartBezirksart getBezirksart() {
        return bezirksart;
      }

  /**
   * 
   *
   * setter for GEBIETSART.BEZIRKSART
   *
   * @param bezirksart
   */
  @Override   public void setBezirksart( de.ivu.elect.business.gebietsbaum.entity.GebietsartBezirksart bezirksart) {

       resetTkCache();
                  de.ivu.elect.business.gebietsbaum.entity.GebietsartBezirksart bezirksartInternal = bezirksart;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bezirksart
      , bezirksartInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBezirksart |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bezirksart");
      }


             if (!isSeitLadenVeraendertBezirksart) {
          isSeitLadenVeraendertBezirksart = thisAttributChanged;
         if (isSeitLadenVeraendertBezirksart){
           wertNachLadenBezirksart=this.bezirksart;
         }
       }
      

       this.bezirksart = bezirksartInternal;

         }

        
      @javax.persistence.Column(name = "DARSTELLUNG", nullable = GebietsartConstants.DARSTELLUNG_NULLABLE, length=GebietsartConstants.DARSTELLUNG_MAX_LENGTH)
        // {0} = (Bezirk)Nummer, {1} = Name, {2} = Kurzname, {3} = Gebietsart, {4} = Gebietsartkennzeichen, {5} = Nummer
  protected java.lang.String darstellung =  "{0} - {1}";

  @javax.persistence.Transient
  protected boolean hasChangedDarstellung = false;

  public boolean hasChangedDarstellung(){
    return hasChangedDarstellung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertDarstellung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenDarstellung;
  
  /**
   * 
   *
   * getter for GEBIETSART.DARSTELLUNG
   */
    @Override   public  java.lang.String getDarstellung() {
        return darstellung;
      }

  /**
   * 
   *
   * setter for GEBIETSART.DARSTELLUNG
   *
   * @param darstellung
   */
  @Override   public void setDarstellung( java.lang.String darstellung) {

       resetTkCache();
                  
                          java.lang.String darstellungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(darstellung, GebietsartConstants.DARSTELLUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.darstellung
      , darstellungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDarstellung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("darstellung");
      }


             if (!isSeitLadenVeraendertDarstellung) {
          isSeitLadenVeraendertDarstellung = thisAttributChanged;
         if (isSeitLadenVeraendertDarstellung){
           wertNachLadenDarstellung=this.darstellung;
         }
       }
      

       this.darstellung = darstellungInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "ICON", nullable = GebietsartConstants.ICON_NULLABLE)
    
  protected de.ivu.elect.business.gebietsbaum.entity.GebietsartIcon icon =  de.ivu.elect.business.gebietsbaum.entity.GebietsartIcon.KEIN;

  @javax.persistence.Transient
  protected boolean hasChangedIcon = false;

  public boolean hasChangedIcon(){
    return hasChangedIcon;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertIcon = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.gebietsbaum.entity.GebietsartIcon wertNachLadenIcon;
  
  /**
   * 
   *
   * getter for GEBIETSART.ICON
   */
    @Override   public  de.ivu.elect.business.gebietsbaum.entity.GebietsartIcon getIcon() {
        return icon;
      }

  /**
   * 
   *
   * setter for GEBIETSART.ICON
   *
   * @param icon
   */
  @Override   public void setIcon( de.ivu.elect.business.gebietsbaum.entity.GebietsartIcon icon) {

       resetTkCache();
                  de.ivu.elect.business.gebietsbaum.entity.GebietsartIcon iconInternal = icon;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.icon
      , iconInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedIcon |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("icon");
      }


             if (!isSeitLadenVeraendertIcon) {
          isSeitLadenVeraendertIcon = thisAttributChanged;
         if (isSeitLadenVeraendertIcon){
           wertNachLadenIcon=this.icon;
         }
       }
      

       this.icon = iconInternal;

         }

        
  @javax.persistence.Column(name = "KENNZEICHEN", nullable = GebietsartConstants.KENNZEICHEN_NULLABLE, length=GebietsartConstants.KENNZEICHEN_MAX_LENGTH)
        
  protected java.lang.String kennzeichen =  null;

  @javax.persistence.Transient
  protected boolean hasChangedKennzeichen = false;

  public boolean hasChangedKennzeichen(){
    return hasChangedKennzeichen;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertKennzeichen = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenKennzeichen;
  
  /**
   * 
   *
   * getter for GEBIETSART.KENNZEICHEN
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getKennzeichen() {
        return kennzeichen;
      }

  /**
   * 
   *
   * setter for GEBIETSART.KENNZEICHEN
   *
   * @param kennzeichen
   */
  @Override   public void setKennzeichen(@javax.annotation.Nullable  java.lang.String kennzeichen) {

       resetTkCache();
                  
                          java.lang.String kennzeichenInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(kennzeichen, GebietsartConstants.KENNZEICHEN_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.kennzeichen
      , kennzeichenInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedKennzeichen |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("kennzeichen");
      }


             if (!isSeitLadenVeraendertKennzeichen) {
          isSeitLadenVeraendertKennzeichen = thisAttributChanged;
         if (isSeitLadenVeraendertKennzeichen){
           wertNachLadenKennzeichen=this.kennzeichen;
         }
       }
      

       this.kennzeichen = kennzeichenInternal;

         }

        
      @javax.persistence.Column(name = "NAME", nullable = GebietsartConstants.NAME_NULLABLE, length=GebietsartConstants.NAME_MAX_LENGTH)
        
  protected String name =  null;

  @javax.persistence.Transient
  protected boolean hasChangedName = false;

  public boolean hasChangedName(){
    return hasChangedName;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertName = false;
     @javax.persistence.Transient
     private transient String wertNachLadenName;
  
  /**
   * 
   *
   * getter for GEBIETSART.NAME
   */
    @Override   public  String getName() {
        return name;
      }

  /**
   * 
   *
   * setter for GEBIETSART.NAME
   *
   * @param name
   */
  @Override   public void setName( String name) {

       resetTkCache();
                  
                          String nameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(name, GebietsartConstants.NAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.name
      , nameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedName |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("name");
      }


             if (!isSeitLadenVeraendertName) {
          isSeitLadenVeraendertName = thisAttributChanged;
         if (isSeitLadenVeraendertName){
           wertNachLadenName=this.name;
         }
       }
      

       this.name = nameInternal;

         }

        
      @javax.persistence.Column(name = "POSITION", nullable = GebietsartConstants.POSITION_NULLABLE, precision=GebietsartConstants.POSITION_PRECISION, scale=GebietsartConstants.POSITION_SCALE)
            
  protected java.lang.Long position =  Long.valueOf("0");

  @javax.persistence.Transient
  protected boolean hasChangedPosition = false;

  public boolean hasChangedPosition(){
    return hasChangedPosition;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertPosition = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenPosition;
  
  /**
   * 
   *
   * getter for GEBIETSART.POSITION
   */
    @Override   public  java.lang.Long getPosition() {
        return position;
      }

  /**
   * 
   *
   * setter for GEBIETSART.POSITION
   *
   * @param position
   */
  @Override   public void setPosition( java.lang.Long position) {

       resetTkCache();
                  java.lang.Long positionInternal = position;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.position
      , positionInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPosition |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("position");
      }


             if (!isSeitLadenVeraendertPosition) {
          isSeitLadenVeraendertPosition = thisAttributChanged;
         if (isSeitLadenVeraendertPosition){
           wertNachLadenPosition=this.position;
         }
       }
      

       this.position = positionInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "SYSTEM_GEBIETSEBENE", nullable = GebietsartConstants.SYSTEM_GEBIETSEBENE_NULLABLE)
    
  protected de.ivu.elect.business.gebietsbaum.entity.GebietSystemGebietsebene systemGebietsebene =  de.ivu.elect.business.gebietsbaum.entity.GebietSystemGebietsebene.OHNE;

  @javax.persistence.Transient
  protected boolean hasChangedSystemGebietsebene = false;

  public boolean hasChangedSystemGebietsebene(){
    return hasChangedSystemGebietsebene;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertSystemGebietsebene = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.gebietsbaum.entity.GebietSystemGebietsebene wertNachLadenSystemGebietsebene;
  
  /**
   * 
   *
   * getter for GEBIETSART.SYSTEM_GEBIETSEBENE
   */
    @Override   public  de.ivu.elect.business.gebietsbaum.entity.GebietSystemGebietsebene getSystemGebietsebene() {
        return systemGebietsebene;
      }

  /**
   * 
   *
   * setter for GEBIETSART.SYSTEM_GEBIETSEBENE
   *
   * @param systemGebietsebene
   */
  @Override   public void setSystemGebietsebene( de.ivu.elect.business.gebietsbaum.entity.GebietSystemGebietsebene systemGebietsebene) {

       resetTkCache();
                  de.ivu.elect.business.gebietsbaum.entity.GebietSystemGebietsebene systemGebietsebeneInternal = systemGebietsebene;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.systemGebietsebene
      , systemGebietsebeneInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedSystemGebietsebene |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("systemGebietsebene");
      }


             if (!isSeitLadenVeraendertSystemGebietsebene) {
          isSeitLadenVeraendertSystemGebietsebene = thisAttributChanged;
         if (isSeitLadenVeraendertSystemGebietsebene){
           wertNachLadenSystemGebietsebene=this.systemGebietsebene;
         }
       }
      

       this.systemGebietsebene = systemGebietsebeneInternal;

         }

        
  @javax.persistence.Column(name = "TITEL", nullable = GebietsartConstants.TITEL_NULLABLE, length=GebietsartConstants.TITEL_MAX_LENGTH)
        
  protected java.lang.String titel =  null;

  @javax.persistence.Transient
  protected boolean hasChangedTitel = false;

  public boolean hasChangedTitel(){
    return hasChangedTitel;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertTitel = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenTitel;
  
  /**
   * 
   *
   * getter for GEBIETSART.TITEL
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getTitel() {
        return titel;
      }

  /**
   * 
   *
   * setter for GEBIETSART.TITEL
   *
   * @param titel
   */
  @Override   public void setTitel(@javax.annotation.Nullable  java.lang.String titel) {

       resetTkCache();
                  
                          java.lang.String titelInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(titel, GebietsartConstants.TITEL_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.titel
      , titelInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedTitel |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("titel");
      }


             if (!isSeitLadenVeraendertTitel) {
          isSeitLadenVeraendertTitel = thisAttributChanged;
         if (isSeitLadenVeraendertTitel){
           wertNachLadenTitel=this.titel;
         }
       }
      

       this.titel = titelInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Mandant
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "MANDANT_ID", referencedColumnName="MANDANT_ID"))
  protected de.ivu.elect.business.mandant.entity.Mandant mandant;

  /**
   * 
   */
  @Override
  public void setMandant( de.ivu.elect.business.mandant.entity.Mandant mandant){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.mandant
    , mandant);

    attributeChanged |= thisAttributChanged;

    hasChangedMandant |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("mandant");
    }

    this.mandant = mandant;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.mandant.entity.Mandant getMandant(){
    return this.mandant;
  }

  @javax.persistence.Transient
  protected boolean hasChangedMandant = false;

  public boolean hasChangedMandant(){
    return hasChangedMandant;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Gebietsart:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Gebietsart other){
                             other.bezirksart = this.bezirksart;
                                other.darstellung = this.darstellung;
                                other.icon = this.icon;
                                other.kennzeichen = this.kennzeichen;
                                other.name = this.name;
                                other.position = this.position;
                                other.systemGebietsebene = this.systemGebietsebene;
                                other.titel = this.titel;
           
  other.setMandant(this.getMandant());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Gebietsart.class)){
        copyEntityAttributesUsingSetter((Gebietsart) other.castTo(Gebietsart.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Gebietsart: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Gebietsart other){
               other.setBezirksart(this.bezirksart);
                  other.setDarstellung(this.darstellung);
                  other.setIcon(this.icon);
                  other.setKennzeichen(this.kennzeichen);
                  other.setName(this.name);
                  other.setPosition(this.position);
                  other.setSystemGebietsebene(this.systemGebietsebene);
                  other.setTitel(this.titel);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Gebietsart other){
                       if (hasChangedBezirksart) {
        other.setBezirksart(this.bezirksart);
      }
                             if (hasChangedDarstellung) {
        other.setDarstellung(this.darstellung);
      }
                             if (hasChangedIcon) {
        other.setIcon(this.icon);
      }
                             if (hasChangedKennzeichen) {
        other.setKennzeichen(this.kennzeichen);
      }
                             if (hasChangedName) {
        other.setName(this.name);
      }
                             if (hasChangedPosition) {
        other.setPosition(this.position);
      }
                             if (hasChangedSystemGebietsebene) {
        other.setSystemGebietsebene(this.systemGebietsebene);
      }
                             if (hasChangedTitel) {
        other.setTitel(this.titel);
      }
             }





    @javax.persistence.Transient
    private transient GebietsartTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public GebietsartTK getGebietsartTK(){
    if (tkCache==null) {
    tkCache = new GebietsartTK(

getName()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getGebietsartTK();
    }

  @Override
  public GebietsartUK getUk(){
    return getGebietsartUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Gebietsart.class;
  }

public GebietsartUK getGebietsartUK(){

   return  new GebietsartUK(

getName()
,     getMandant()==null?null:getMandant().getMandantUK()


  );
}

  @javax.persistence.Transient
  private transient GebietsartProperties properties;

  public GebietsartProperties getProperties(){
    if (properties == null) {
      properties = new GebietsartProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public GebietsartProperties getGebietsartProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return GebietsartConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(GebietsartConstants.MESSAGE_KEY_BEZIRKSART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(GebietsartConstants.MESSAGE_KEY_BEZIRKSART_EINZAHL);

        bezirksart =
     (de.ivu.elect.business.gebietsbaum.entity.GebietsartBezirksart) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(GebietsartConstants.MESSAGE_KEY_DARSTELLUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(GebietsartConstants.MESSAGE_KEY_DARSTELLUNG_EINZAHL);

        darstellung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(GebietsartConstants.MESSAGE_KEY_ICON_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(GebietsartConstants.MESSAGE_KEY_ICON_EINZAHL);

        icon =
     (de.ivu.elect.business.gebietsbaum.entity.GebietsartIcon) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(GebietsartConstants.MESSAGE_KEY_KENNZEICHEN_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(GebietsartConstants.MESSAGE_KEY_KENNZEICHEN_EINZAHL);

        kennzeichen =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(GebietsartConstants.MESSAGE_KEY_NAME_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(GebietsartConstants.MESSAGE_KEY_NAME_EINZAHL);

        name =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(GebietsartConstants.MESSAGE_KEY_POSITION_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(GebietsartConstants.MESSAGE_KEY_POSITION_EINZAHL);

        position =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

            
      if (werteVorher.containsKey(GebietsartConstants.MESSAGE_KEY_SYSTEM_GEBIETSEBENE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(GebietsartConstants.MESSAGE_KEY_SYSTEM_GEBIETSEBENE_EINZAHL);

        systemGebietsebene =
     (de.ivu.elect.business.gebietsbaum.entity.GebietSystemGebietsebene) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(GebietsartConstants.MESSAGE_KEY_TITEL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(GebietsartConstants.MESSAGE_KEY_TITEL_EINZAHL);

        titel =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBezirksart) {
      result.put(GebietsartConstants.MESSAGE_KEY_BEZIRKSART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenBezirksart , bezirksart));
    }
                            if (isSeitLadenVeraendertDarstellung) {
      result.put(GebietsartConstants.MESSAGE_KEY_DARSTELLUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenDarstellung , darstellung));
    }
                            if (isSeitLadenVeraendertIcon) {
      result.put(GebietsartConstants.MESSAGE_KEY_ICON_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenIcon , icon));
    }
                            if (isSeitLadenVeraendertKennzeichen) {
      result.put(GebietsartConstants.MESSAGE_KEY_KENNZEICHEN_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenKennzeichen , kennzeichen));
    }
                            if (isSeitLadenVeraendertName) {
      result.put(GebietsartConstants.MESSAGE_KEY_NAME_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenName , name));
    }
                            if (isSeitLadenVeraendertPosition) {
      result.put(GebietsartConstants.MESSAGE_KEY_POSITION_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenPosition , position));
    }
                            if (isSeitLadenVeraendertSystemGebietsebene) {
      result.put(GebietsartConstants.MESSAGE_KEY_SYSTEM_GEBIETSEBENE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenSystemGebietsebene , systemGebietsebene));
    }
                            if (isSeitLadenVeraendertTitel) {
      result.put(GebietsartConstants.MESSAGE_KEY_TITEL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenTitel , titel));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBezirksart = false;
      wertNachLadenBezirksart = null;
                          isSeitLadenVeraendertDarstellung = false;
      wertNachLadenDarstellung = null;
                          isSeitLadenVeraendertIcon = false;
      wertNachLadenIcon = null;
                          isSeitLadenVeraendertKennzeichen = false;
      wertNachLadenKennzeichen = null;
                          isSeitLadenVeraendertName = false;
      wertNachLadenName = null;
                          isSeitLadenVeraendertPosition = false;
      wertNachLadenPosition = null;
                          isSeitLadenVeraendertSystemGebietsebene = false;
      wertNachLadenSystemGebietsebene = null;
                          isSeitLadenVeraendertTitel = false;
      wertNachLadenTitel = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "GEBIETSART";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Gebietsart";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(bezirksart, this, GebietsartConstants.MESSAGE_KEY_BEZIRKSART_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(darstellung, this, GebietsartConstants.MESSAGE_KEY_DARSTELLUNG_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(GebietsartConstants.DARSTELLUNG_MAX_LENGTH , 1 ,  darstellung, this, GebietsartConstants.MESSAGE_KEY_DARSTELLUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(icon, this, GebietsartConstants.MESSAGE_KEY_ICON_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(GebietsartConstants.KENNZEICHEN_MAX_LENGTH ,  kennzeichen, this, GebietsartConstants.MESSAGE_KEY_KENNZEICHEN_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(name, this, GebietsartConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(GebietsartConstants.NAME_MAX_LENGTH , 1 ,  name, this, GebietsartConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(position, this, GebietsartConstants.MESSAGE_KEY_POSITION_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(GebietsartConstants.POSITION_MAX_VALUE, GebietsartConstants.POSITION_MIN_VALUE, position, this, GebietsartConstants.MESSAGE_KEY_POSITION_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(systemGebietsebene, this, GebietsartConstants.MESSAGE_KEY_SYSTEM_GEBIETSEBENE_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(GebietsartConstants.TITEL_MAX_LENGTH ,  titel, this, GebietsartConstants.MESSAGE_KEY_TITEL_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
